<%  @ LANGUAGE=VBScript %>
<%  Option Explicit %>
<!--#include file="config.inc" -->
<% 
  '
  ' This file returns the actual image to the browser. 
  ' The referring page (i.e. the one containing the image) contains an image tag 
  ' such as: 
  ' <img src="getimage.asp?field=Image&imgid=12" width="163" height="140" alt="Picture"> 
  ' The server processes this file as it would any other asp script.  In it we
  ' open the database and extract the requested image.
  ' We set-up the MIME headers that we'll send back to the browser so that 
  ' the data stream will be interpreted by the browser as an image.  The browser receives the 
  ' image and displays it just as if it was a conventional file.
%>

<%
  Dim SQL
  Dim m_sSourceID
  Dim oConn ' Connection object
  Dim oRs   ' Recordset object
  Dim strField   ' Recordset object

  ' Setup HTTP Header Information so that the browser interprets
  ' the returned data as a graphic file. Note that browsers
  ' interpret returned information using MIME headers -- not file
  ' extensions.
  Response.Buffer = TRUE
  Response.ContentType = "image/jpeg"

  ' Open a connection to the database.
  ' The connection string is defined in the include file "config.inc".
  Set oConn = Server.CreateObject("ADODB.Connection")
  oConn.Open GetConnectString

  ' Get the requested image id from the request object
  ' For example, if the request url was "getimage.asp?field=Thumb&imgid=21" 
  ' then Request("imgid") would return 21
  m_sSourceID = Request("imgid")

  ' the 'field' parameter is used to identify which image field we want from the recordset,
  ' eg the Thumbnail or Main image field
  strField = Request("field")

  ' Check that a valid id was passed
  If (m_sSourceID <> "") Then 

    ' Prepare the Query
    SQL = "SELECT tPhotos.Id, tPhotos." & strField & " FROM tPhotos"
    SQL = SQL & " WHERE Id = " & m_sSourceID

    ' Execute the query and get the returned recordset
    Set oRs = oConn.Execute(SQL)

    ' Make sure we have a record
    if NOT (oRs.EOF AND oRs.BOF) then

      ' Make sure that the image field contains some data
      if oRs(strField).ActualSize > 0 then

        ' Write Data back to client. Because MIME type is set to
        ' image/jpeg the browser will automatically render as an image
        ' without needing controls, applets etc.
        Response.BinaryWrite oRs(strField).GetChunk(oRs(strField).ActualSize)

      end if
    end if
    oRs.Close
    Set oRs = nothing
  end if
  Set oConn = nothing

  Response.End
%>
